indexing

   title:       "Container for the arguments array";
   cluster:     "format/science [format/science]";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Andy Malakov  (andy@eiffel.ru) and";
   original:    08,Sep,1995;
   version:     1.0;
   last_change:
   done_at:     "SIG Computer (info@eiffel.ru)";
   extrnl_name: "arg_iter.e"

class ARGUMENTS_ITERATOR
      -- iterate all arguments from argument array

   creation make

   -------------------------------------------------------------------
   feature

      ----------------------------------------------------------------
      make ( a : ARRAY [ ANY] ) is
         do
            arg := a
            if arg /= Void then
               cur := arg.lower
            end
         end
      ----------------------------------------------------------------
      current_item : ANY is
         do
            if arg = Void or else cur > arg.upper then
               raise_exception ( "Not enough arguments" )
            else
               Result := arg @ cur
            end
         ensure
            Result /= Void
         end
      ----------------------------------------------------------------
      go_forth is require arg /= Void do   cur := cur + 1   end
      ----------------------------------------------------------------
      check_finished is
            -- all arguments taken?
         do
            if arg /= Void and then cur <= arg.upper then
               raise_exception ( "Too much arguments" )
            end
         end

      ----------------------------------------------------------------
      arg : ARRAY [ ANY ] -- iterated array
      ----------------------------------------------------------------

   feature { NONE }

      cur : INTEGER

      ----------------------------------------------------------------
      exc : ERROR_HANDLER is once !!Result end
      raise_exception ( msg : STRING ) is
         local
            m : STRING
            tools : STRING_TOOLS
         do
            !!tools
            --!!m.adapt ("Bad format (")
            !!m.make(0) tools.x_adapt (m,"Bad format (")
            --m.append (msg)
            tools.x_append (m,msg)
            --m.extend (')')
            tools.x_extend (m,')')
            exc.raise ( "SCIENTIFIC_FORMAT", m, 0, Current )
         end -- raise_exception

end -- class ARGUMENTS_ITERATOR
