indexing


class ERROR_HANDLER

   ---------------------------------------------------------------------------
   feature -- Operations

      raise (name, msg: STRING; code: INTEGER; xobject: ANY) is
            -- builds error report according to the actual argument list,
            -- prints it and raises a user defined exception: if proper
            -- 'error_types.item (code)' is defined it'll be used as 'msg'
            -- supplement otherwise only numeric 'code' is appended to ...
            -- (this routine is supported by Eiffel/S of SIG Computer GmbH)
            --
         require
            valid_name:  name /= Void
         local
            io:     STD_FILES;
         do
            -- Building final error message ...
            --

            -- Printing out the error report ...
            --
            !!io;
            io.put_string ("%NError: ");
            io.put_string (msg);
            io.put_string (" class: ");
            io.put_string (name);
            io.put_new_line;

            -- Raising a user defined exception which stops the execution ...
            --
            sig.raise (name, msg, 0, xobject)
         end

   ---------------------------------------------------------------------------
   feature -- Queries

      error_types: ARRAY [STRING]

   ---------------------------------------------------------------------------
   feature {NONE} -- Implementation

      sig: EXCEPTION is
            -- this routine is supported by Eiffel/S of SIG Computer GmbH
         once
            !!Result
         end;

end -- ERROR_HANDLER
